
\input{shape-sll2dll}

{\bf Pure-Property Extension. } By the
\form{\infer ~ [@size]} command,
 the user triggers an inference for the size constraints. % of each list.
Through predicate extension mechanism, HIP injects the size property (captured by \code{n})
into the predicate \code{sll}  to derive
a predicate \code{llN} as:
\[
\begin{array}[t]{l}
\code{\defpred~\view{llN}{hd,n}} ~{\veq}~
(\code{\emp {\wedge} hd{=}\nil \wedge n{=}0}) \\
\code{~{\vee}~\exists \, nx,m {\cdot} (\hformn{hd}{node}{\anon,nx}}
\code{~{\sep}~\hformp{nx}{llN}{m}~{\wedge}~n{=}m{+}1).}
 \end{array}
\]

Similarly, the \code{dllN} predicate is generated as follows:
\[
\begin{array}[t]{l}
\code{\defpred~\view{dllN}{hd,p,n}} ~{\veq}~
(\code{\emp {\wedge} hd{=}\nil \wedge n{=}0}) \\
\code{~{\vee}~\exists \, nx,m {\cdot} (\hformn{hd}{node}{q,nx}}
\code{~{\sep}~\hformp{nx}{dllN}{hd,m}~{\wedge}~n{=}m{+}1).}
 \end{array}
\]
{\bf Pure Inference. }
 By the command
\form{\infer ~ [@pre,@post]},
(i.e. the user would like to
 infer the specification with the size
of each list), HIP internally
 strengthens
the pre/post specification for \code{sll2dll} to include
uninterpreted relations:
\code{P(a)} in the precondition 
and \code{Q(a,b)} in the postcondition as follows.
\[
\begin{array}[t]{l}
  \code{infer ~ [P,Q]} \\
  \code{\requires ~ \view{sllN}{x,q,a}~ {\wedge}~ P(a)} \\
  \code{\ensures ~~~ \view{dllN}{x,q,b} ~ {\wedge}~ Q(a,b);}\\
\end{array}
\]
Here the inference will be applied to the second-order variables \code{P,Q}.
They are meant to capture the relationship
between the newly-introduced variables \code{a,b}
denoting size properties of linked lists.
Uninterpreted relations in the precondition should be as weak as possible,
while ones in the postcondition should be as strong as possible.
 %% Intuitively, it is meant to incorporate the inference
%% capability (via \code{infer}) into a pair
%% of pre/post-condition (via \code{\requires}/\code{\ensures}).
By analysing the \code{sll2dll} code, our procedure gathers the following
relational assumptions: % on the two second-order variables:
\[
\begin{array}[t]{l}
\code{P(a) ~ {\wedge}~ a{=}ar{+}1
  ~{\Longrightarrow}~  P(ar),}\\
\code{P(a) ~{\wedge}~  a{=}0 ~{\wedge}~ b{=}0   ~{\Longrightarrow}~  Q(a,b),}\\
\code{P(a) {\wedge} an{=}a{-}1 {\wedge}bn{=}b{-}1 {\wedge}}
\code{Q(an,bn) ~{\Longrightarrow}~   Q(a,b).}
\end{array}
\]

\hide{
RELDEFN pre_1615: ( pre_1615(n) & n_1639+1=n) -->  pre_1615(n_1639),
RELDEFN post_1616: ( post_1616(m_1647,n_1639) & m_1590=1+m_1647 & n_1639+1=n & pre_1615(n)) -->  post_1616(m_1590,n),
RELDEFN post_1616: ( m_1590=0 & n=0 & pre_1615(n)) -->  post_1616(m_1590,n)]}


\noindent Using suitable fix-point analysis techniques, we can
synthesize the approximations which
would add a pure post-condition \code{b{=}a} for the size properties. More specifically, we have
\code{P(a) ~{\equiv}~ \true},
\code{Q(a,b) ~{\equiv}~ a{=}b \wedge b{\geq}0}
and a new specification that ensures memory safety:
\[
\begin{array}[t]{l}
  \code{\requires ~ \view{sllN}{x,a}} \\
  \code{\ensures ~~~ \view{dllN}{x,q,b} ~ {\wedge}~ b{=}a \wedge b{\geq}0;}
\end{array}
\]
